static void PMDWINSaveSetting(void)
{
	char key[MAX_PATH];
	int i, dirnum;
	SetSettingString("RhythmWaveFilePath", setting.rhythmpath);

	for (i = 0; freqlist[i].key != NULL; i++)
	{
		if (setting.frequency == freqlist[i].num) break;
	}
	if (freqlist[i].key == NULL) i = 0;
	SetSettingString("Frequency", freqlist[i].key);

	for (i = 0; priolist[i].key != NULL; i++)
	{
		if (setting.priority == priolist[i].num) break;
	}
	if (priolist[i].key == NULL) i = 2;
	SetSettingString("Priority", priolist[i].key);

	SetSettingInt("LoopCount"   , setting.loopcount);
	SetSettingInt("FadeoutTime" , setting.fadetime);

	for (dirnum = setting.pcmdirnum, i = 0; i < dirnum; i++)
	{
		wsprintf(key, "PcmPath%d", i+1);
		SetSettingString(key, setting.pcmdir[i]);
	}
	dirnum += 10;
	if (dirnum > 64) dirnum = 64;
	for (; i < dirnum; i++)
	{
		wsprintf(key, "PcmPath%d", i+1);
		SetSettingString(key, "");
	}
	for (; i < 64; i++)
	{
		wsprintf(key, "PcmPath%d", i+1);
		SetSettingString(key, NULL);
	}
}

static void PMDWINLoadSetting(void)
{
	LPTSTR fnoff;
	char path[MAX_PATH];
	int i, dirnum;

	GetFullPathName(setting.cfgname, MAX_PATH, path, &fnoff);
	path[(fnoff - path)] = '\0';
	GetSettingString("RhythmWaveFilePath", path, setting.rhythmpath, sizeof(setting.rhythmpath));
	setting.currentrhythmpath[0] = '\0';

	GetSettingString("Frequency", freqlist[0].key, path, sizeof(path));
	for (i = 0; freqlist[i].key != NULL; i++)
	{
		if (lstrcmpi(path, freqlist[i].key) == 0) break;
	}
	setting.frequency = freqlist[i].num;

	GetSettingString("Priority", priolist[2].key, path, sizeof(path));
	for (i = 0; priolist[i].key != NULL; i++)
	{
		if (lstrcmpi(path, priolist[i].key) == 0) break;
	}
	setting.priority = priolist[i].num;

	setting.loopcount = GetSettingInt("LoopCount"   , 2);
	setting.fadetime  = GetSettingInt("FadeoutTime" , 5000);

	for (dirnum = i = 0; i < 64; i++)
	{
		char key[MAX_PATH];
		wsprintf(key, "PcmPath%d", i);
		GetSettingString(key, "", path, sizeof(path));
		if (*path != '\0')
		{
			lstrcpy(setting.pcmdir[dirnum], path);
			setting.pcmdirlist[dirnum] = setting.pcmdir[dirnum];
			dirnum++;
		}
	}
	setting.pcmdirlist[dirnum] = NULL;
	setting.pcmdirnum = dirnum;
	PMDWINSaveSetting();
}

static void PMDWINApplySetting(HWND hwndDlg)
{
	int i, dirnum;
	char buf[MAX_PATH];
	BOOL bFlag;

	GetDlgItemText(hwndDlg, IDC_RHYTHM, setting.rhythmpath, sizeof(setting.rhythmpath));

	GetDlgItemText(hwndDlg, IDC_PRIORITY, buf, sizeof(buf));
	for (i = 0; priolist[i].key != NULL; i++)
	{
		if (lstrcmpi(buf, priolist[i].key) == 0) break;
	}
	setting.priority = priolist[i].num;

	GetDlgItemText(hwndDlg, IDC_FREQUENCY, buf, sizeof(buf));
	for (i = 0; freqlist[i].key != NULL; i++)
	{
		if (lstrcmpi(buf, freqlist[i].key) == 0) break;
	}
	setting.frequency = freqlist[i].num;

	setting.loopcount = GetDlgItemInt(hwndDlg, IDC_LOOP, &bFlag, FALSE);
	if (bFlag == FALSE || setting.loopcount > 0xff)
		setting.loopcount = 2;

	setting.fadetime = GetDlgItemInt(hwndDlg, IDC_FADEOUT, &bFlag, FALSE);
	if (bFlag == FALSE || setting.fadetime > 0x7fff)
		setting.fadetime = 5000;

	SendDlgItemMessage(hwndDlg, IDC_PCMFOLDERLIST, LB_GETCOUNT, 0, 0);
	for (dirnum = i = 0; i < 0x8000; i++)
	{
		if (sizeof(buf) < SendDlgItemMessage(hwndDlg, IDC_PCMFOLDERLIST, LB_GETTEXTLEN, i, 0)) continue;
		SendDlgItemMessage(hwndDlg, IDC_PCMFOLDERLIST, LB_GETTEXT, i, (LPARAM)buf);
		if (*buf != '\0')
		{
			lstrcpy(setting.pcmdir[dirnum], buf);
			setting.pcmdirlist[dirnum] = setting.pcmdir[dirnum];
			dirnum++;
		}
	}
	setting.pcmdirlist[dirnum] = NULL;
	setting.pcmdirnum = dirnum;

	PMDWINSaveSetting();
}

static BOOL CALLBACK PMDWINSettingProc(
	HWND hwndDlg,
	UINT uMsg,
	WPARAM wParam,
	LPARAM lParam
)
{
	int i;
#define MAXX(a,b) ((a > b) ? a : b)
	char buf[MAXX(512, MAX_PATH)];
	switch (uMsg)
	{
		case WM_INITDIALOG:
			SendDlgItemMessage(hwndDlg, IDC_PRIORITY, CB_SETEXTENDEDUI, TRUE, 0);
			for (i = 0; priolist[i].key != NULL; i++)
			{
				SendDlgItemMessage(hwndDlg, IDC_PRIORITY, CB_ADDSTRING, 0, (LPARAM)priolist[i].key);
			}
			for (i = 0; priolist[i].key != NULL; i++)
			{
				if (setting.priority == priolist[i].num) break;
			}
			if (priolist[i].key == NULL) i = 2;
			SendDlgItemMessage(hwndDlg, IDC_PRIORITY, CB_SELECTSTRING, -1, (LPARAM)priolist[i].key);

			SendDlgItemMessage(hwndDlg, IDC_FREQUENCY, CB_SETEXTENDEDUI, TRUE, 0);
			for (i = 0; freqlist[i].key != NULL; i++)
			{
				SendDlgItemMessage(hwndDlg, IDC_FREQUENCY, CB_ADDSTRING, 0, (LPARAM)freqlist[i].key);
			}
			for (i = 0; freqlist[i].key != NULL; i++)
			{
				if (setting.frequency == freqlist[i].num) break;
			}
			if (freqlist[i].key == NULL) i = 0;
			SendDlgItemMessage(hwndDlg, IDC_FREQUENCY, CB_SELECTSTRING, -1, (LPARAM)freqlist[i].key);

			SetDlgItemText(hwndDlg, IDC_RHYTHM, setting.rhythmpath);

			SetDlgItemInt(hwndDlg, IDC_LOOP, setting.loopcount, FALSE);
			SendDlgItemMessage(hwndDlg, IDC_SPINLOOP, UDM_SETRANGE, 0, MAKELONG(0xff,0));
			SetDlgItemInt(hwndDlg, IDC_FADEOUT, setting.fadetime, FALSE);
			SendDlgItemMessage(hwndDlg, IDC_SPINFADE, UDM_SETRANGE, 0, MAKELONG(0x7fff,0));

			for (i = 0; i < setting.pcmdirnum; i++)
			{
				if (LB_ERR == SendDlgItemMessage(hwndDlg, IDC_PCMFOLDERLIST, LB_FINDSTRING, 0, (LPARAM)setting.pcmdir[i]))
					SendDlgItemMessage(hwndDlg, IDC_PCMFOLDERLIST, LB_ADDSTRING, 0, (LPARAM)setting.pcmdir[i]);
			}
			return TRUE;
		case WM_NOTIFY:
			if (PSN_APPLY == ((LPNMHDR)lParam)->code)
			{
				PMDWINApplySetting(hwndDlg);
				return TRUE;
			}
			break;
		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
			case IDC_FADEOUT:
			case IDC_LOOP:
				if (HIWORD(wParam) == EN_UPDATE)
				{
					return TRUE;
				}
				break;
			case IDC_PRIORITY:
			case IDC_FREQUENCY:
				if (HIWORD(wParam) == CBN_SELCHANGE)
				{
					return TRUE;
				}
				break;
			case IDC_RHYTHMBROWSE:
			case IDC_PCMFOLDERBROWSE:
				if (HIWORD(wParam) == BN_CLICKED)
				{
					LPMALLOC lpMalloc = NULL;
					LPITEMIDLIST lpidlFolder = NULL;
					do
					{
						BROWSEINFO bi;
						if (FAILED(SHGetMalloc(&lpMalloc))) break;
						bi.hwndOwner = hwndDlg;
						bi.pidlRoot = NULL;
						bi.pszDisplayName = buf;
						bi.lpszTitle = (LOWORD(wParam) == IDC_RHYTHMBROWSE)
							? "Rhythm WAV Files Folder"
							: "PCM Files Search Folders";
						bi.ulFlags = BIF_RETURNONLYFSDIRS;
						bi.lpfn = NULL;
						bi.lParam = 0;
						bi.iImage = 0;
						lpidlFolder = SHBrowseForFolder(&bi);
						if (lpidlFolder == NULL) break;
						if (FALSE == SHGetPathFromIDList(lpidlFolder, buf)) break;
						if (LOWORD(wParam) == IDC_RHYTHMBROWSE)
							SetDlgItemText(hwndDlg,  IDC_RHYTHM, buf);
						else if (LB_ERR == SendDlgItemMessage(hwndDlg, IDC_PCMFOLDERLIST, LB_FINDSTRING, 0, (LPARAM)buf))
							SendDlgItemMessage(hwndDlg, IDC_PCMFOLDERLIST, LB_ADDSTRING, 0, (LPARAM)buf);
						else
							break;
					} while(0);
#if !defined(IMalloc_Free)
#ifdef __cplusplus
#define IMalloc_Free(t,p) t->Free(p)
#else
#define IMalloc_Free(t,p) t->lpVtbl->Free(t, p)
#endif
#endif
#if !defined(IMalloc_Release)
#ifdef __cplusplus
#define IMalloc_Release(t) t->Release()
#else
#define IMalloc_Release(t) t->lpVtbl->Release(t)
#endif
#endif
					if (lpidlFolder != NULL)
						IMalloc_Free(lpMalloc, lpidlFolder);
					if (lpMalloc != NULL)
						IMalloc_Release(lpMalloc);
					return TRUE;
				}
				break;
			case IDC_PCMFOLDER:
				if (HIWORD(wParam) == EN_MAXTEXT)
				{
					GetDlgItemText(hwndDlg, IDC_PCMFOLDER, buf, sizeof(buf));
					if (*buf == '\0') break;
					if (LB_ERR == SendDlgItemMessage(hwndDlg, IDC_PCMFOLDERLIST, LB_FINDSTRING, 0, (LPARAM)buf))
					{
						SendDlgItemMessage(hwndDlg, IDC_PCMFOLDERLIST, LB_ADDSTRING, 0, (LPARAM)buf);
						SetDlgItemText(hwndDlg, IDC_PCMFOLDER, "");
					}
					return TRUE;
				}
				break;
			case IDC_PCMFOLDERREMOVE:
				if (HIWORD(wParam) == BN_CLICKED)
				{
					LONG idx;
					idx = SendDlgItemMessage(hwndDlg, IDC_PCMFOLDERLIST, LB_GETCURSEL ,0, 0);
					if (idx == LB_ERR) break;
					SendDlgItemMessage(hwndDlg, IDC_PCMFOLDERLIST, LB_DELETESTRING, idx, 0);
					return TRUE;
				}
				break;
			case IDC_PCMFOLDERCLEAR:
				if (HIWORD(wParam) == BN_CLICKED)
				{
					SendDlgItemMessage(hwndDlg, IDC_PCMFOLDERLIST, LB_RESETCONTENT, 0, 0);
					//PropSheet_Changed(hwndDlg, PropSheet_GetCurrentPageHwnd(hwndDlg));
					return TRUE;
				}
				break;
			}
			break;
	}
	return FALSE;
}
